## Load some library
library("e1071")
library(foreach)
library(doParallel)

registerDoParallel(4) # Set the number of cores (usually, number of available core +1

load("astrostat.RData")

n=nrow(x)
d=ncol(x)
C = max(y)

numberTrain = 100 # Select "numberTrain" per class for training
numberTest = 6300-numberTrain # The remaining is for validation

## Initialization of the training/validation sets
xt = matrix(0,numberTrain*C,d)
yt = matrix(0,numberTrain*C,1)
xT = matrix(0,numberTest*C,d)
yT = matrix(0,numberTest*C,1)

for (i in 1:C)
{
  t = which(y==i)
  ts = sample(t) # Permute ramdomly the samples for class i
  xt[(1+numberTrain*(i-1)):(numberTrain*i),]=x[ts[1:numberTrain],]
  yt[(1+numberTrain*(i-1)):(numberTrain*i),]=y[ts[1:numberTrain],]
  
  xT[(1+numberTest*(i-1)):(numberTest*i),]=x[ts[(numberTrain+1):6300],]
  yT[(1+numberTest*(i-1)):(numberTest*i),]=y[ts[(numberTrain+1):6300],]       
}

# KK-NN
p = 1
normxT = rowSums(xT*xT)
normxt = rowSums(xt*xt)
K = outer(normxT^p,normxt^p,"+") - 2*(xT%*%t(xt))^p
indices = apply(K,1,which.min)
yp = matrix(0,nrow(xT),1)
for (i in 1:nrow(xT))
{
  yp[i]=yt[indices[i]]
}
# Confusion matrix
confu = table(yT,yp)
OA = sum(diag(confu))/sum(confu)
